package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTMarkNode_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTMarkNode extends ISLASTNode  {
	
	/* @generated */
	protected ISLASTMarkNode(long ptr) {
		/*** PROTECTED REGION ID(ISLASTMarkNode_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTMarkNode build(long ptr) {
		return new ISLASTMarkNode(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTMarkNode_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_node_mark_get_id 
	 * 
	 * @generated
	**/
	public ISLIdentifier getID() {
		/*** PROTECTED REGION ID(isl_ast_node_mark_get_id) DISABLED START ***/
		ISLIdentifier res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLIdentifier.build(ISLNative.isl_ast_node_mark_get_id(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_node_mark_get_node 
	 * 
	 * @generated
	**/
	public ISLASTNode getNode() {
		/*** PROTECTED REGION ID(isl_ast_node_mark_get_node) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_node_mark_get_node(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public void accept(IISLASTNodeVisitor visitor) {
		visitor.visitISLASTMarkNode(this);
	}
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTMarkNode_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
